/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.60 Revision 1.112
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.60 2010/01/13 19:35:01 abcd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.112 2011/12/30 14:39:26 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
17MY_PV=${PV/_/-} 14MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 15MY_P=qt-everywhere-opensource-src-${MY_PV}
20else 16
21 MY_P=qt-x11-opensource-src-${MY_PV} 17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
22fi 29fi
23 30
24HOMEPAGE="http://qt.nokia.com/" 31DEPEND="dev-util/pkgconfig"
25SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
26
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28IUSE="debug pch aqua"
29
30RDEPEND=" 32RDEPEND="
31 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
32 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
33 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
34 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
35 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
36 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
37 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
38 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
39 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
40 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
41 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
42 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
43 !<x11-libs/qt-phonon-${PV} 49 !<x11-libs/qt-phonon-${PV}
44 !>x11-libs/qt-phonon-${PV}-r9999 50 !>x11-libs/qt-phonon-${PV}-r9999
45 !<x11-libs/qt-qt3support-${PV} 51 !<x11-libs/qt-qt3support-${PV}
60 66
61S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
62 68
63# @FUNCTION: qt4-build_pkg_setup 69# @FUNCTION: qt4-build_pkg_setup
64# @DESCRIPTION: 70# @DESCRIPTION:
65# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 71# Sets up PATH and LD_LIBRARY_PATH.
66qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
67 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
68 74
75 # Protect users by not allowing downgrades between releases
76 # Downgrading revisions within the same release should be allowed
77 if has_version '>'${CATEGORY}/${P}-r9999; then
78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:"
80 eerror " Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system"
82 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
84 fi
85 fi
86
87 if [[ ${PN} == "qt-webkit" ]]; then
88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi
97 eshopts_pop
98 fi
69 99
70 PATH="${S}/bin${PATH:+:}${PATH}" 100 PATH="${S}/bin${PATH:+:}${PATH}"
71 if [[ ${CHOST} != *-darwin* ]]; then 101 if [[ ${CHOST} != *-darwin* ]]; then
72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
73 else 103 else
74 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}" 104 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
75 # on mac we *need* src/gui/kernel/qapplication_mac.cpp for platfrom 105 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
76 # detection since the x11-headers package b0rkens the header 106 # platform detection. Note: needs to come before any directories to
77 # installation, we have to extract src/ and include/ completely on mac 107 # avoid extract failure.
78 # tools is needed for qt-demo and some others 108 [[ ${CHOST} == *-apple-darwin* ]] && \
79 QT4_EXTRACT_DIRECTORIES+=" src include" 109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
80
81 if [[ ${PN} == qt-demo || ${PN} == qt-qt3support || ${PN} == qt-webkit ]]; then
82 QT4_EXTRACT_DIRECTORIES+=" tools" 110 ${QT4_EXTRACT_DIRECTORIES}"
83 fi
84 fi 111 fi
85 112
86 # Make sure ebuilds use the required EAPI 113 # Make sure ebuilds use the required EAPI
87 if [[ ${EAPI} != [23] ]]; then 114 if [[ ${EAPI} != [23] ]]; then
88 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using" 115 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
91 die "qt4-build eclass requires EAPI=2 or EAPI=3" 118 die "qt4-build eclass requires EAPI=2 or EAPI=3"
92 fi 119 fi
93 120
94 if ! version_is_at_least 4.1 $(gcc-version); then 121 if ! version_is_at_least 4.1 $(gcc-version); then
95 ewarn "Using a GCC version lower than 4.1 is not supported!" 122 ewarn "Using a GCC version lower than 4.1 is not supported!"
96 echo
97 ebeep 3
98 fi 123 fi
99} 124}
100 125
101# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
102# @DESCRIPTION: 127# @DESCRIPTION:
103# Arguments for build_target_directories. Takes the directories, in which the 128# Arguments for build_target_directories. Takes the directories in which the
104# code should be compiled. This is a space-separated list 129# code should be compiled. This is a space-separated list.
105 130
106# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
107# @DESCRIPTION: 132# @DESCRIPTION:
108# Space separated list including the directories that will be extracted from Qt 133# Space-separated list including the directories that will be extracted from
109# tarball 134# Qt tarball.
110 135
111# @FUNCTION: qt4-build_src_unpack 136# @FUNCTION: qt4-build_src_unpack
112# @DESCRIPTION: 137# @DESCRIPTION:
113# Unpacks the sources 138# Unpacks the sources.
114qt4-build_src_unpack() { 139qt4-build_src_unpack() {
115 setqtenv 140 setqtenv
116 local target targets= 141
142 local tarball="${MY_P}.tar.gz" target= targets=
117 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
118 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 144 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
119 ${QT4_EXTRACT_DIRECTORIES}; do 145 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146 do
120 targets+=" ${MY_P}/${target}" 147 targets+="${MY_P}/${target} "
121 done 148 done
122 149
123 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 150 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
124 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 151 tar -xzf "${DISTDIR}/${tarball}" ${targets}
152 eend $? || die "failed to unpack"
125} 153}
126 154
127# @ECLASS-VARIABLE: PATCHES 155# @ECLASS-VARIABLE: PATCHES
156# @DEFAULT_UNSET
128# @DESCRIPTION: 157# @DESCRIPTION:
129# In case you have patches to apply, specify them in PATCHES variable. Make sure 158# PATCHES array variable containing all various patches to be applied.
130# to specify the full path. This variable is necessary for src_prepare phase. 159# This variable is expected to be defined in global scope of ebuild.
131# example: 160# Make sure to specify the full path. This variable is utilised in
132# PATCHES="${FILESDIR}"/mypatch.patch 161# src_unpack/src_prepare phase, based on EAPI.
133# ${FILESDIR}"/mypatch2.patch"
134# 162#
163# @CODE
164# PATCHES=( "${FILESDIR}/mypatch.patch"
165# "${FILESDIR}/patches_folder/" )
166# @CODE
135 167
136# @FUNCTION: qt4-build_src_prepare 168# @FUNCTION: qt4-build_src_prepare
137# @DESCRIPTION: 169# @DESCRIPTION:
138# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 170# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
139# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 171# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
140qt4-build_src_prepare() { 172qt4-build_src_prepare() {
141 setqtenv 173 setqtenv
142 cd "${S}" 174 cd "${S}"
143 175
176 if version_is_at_least "4.7"; then
177 # fix libX11 dependency on non X packages
178 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
179 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180
181 qt_assistant_cleanup
182 fi
183
144 if use aqua; then 184 if use aqua; then
145 # provide a proper macx-g++-64 185 # provide a proper macx-g++-64
146 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 186 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
147 187
148 sed -e '/^CONFIG/s:app_bundle::' \ 188 sed -e '/^CONFIG/s:app_bundle::' \
149 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 189 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
150 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 190 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
151 fi 191 fi
152 192
153 if [[ ${PN} != qt-core ]]; then 193 if [[ ${PN} != qt-core ]]; then
154 skip_qmake_build_patch 194 skip_qmake_build
155 skip_project_generation_patch 195 skip_project_generation
156 symlink_binaries_to_buildtree 196 symlink_binaries_to_buildtree
157 fi 197 fi
158 198
159 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 199 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
160 # qmake bus errors with -O2 but -O3 works 200 # qmake bus errors with -O2 but -O3 works
161 replace-flags -O2 -O3 201 replace-flags -O2 -O3
162 fi 202 fi
163
164 # Bug 282984 && Bug 295530
165 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \
166 -i configure || die "sed qmake compilers failed"
167 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \
168 -i config.tests/unix/compile.test || die "sed test compilers failed"
169 203
170 # Bug 178652 204 # Bug 178652
171 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 205 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
172 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
173 append-flags -fno-gcse 207 append-flags -fno-gcse
208 fi
209
210 if use_if_iuse c++0x; then
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 append-flags -std=c++0x
174 fi 217 fi
175 218
176 # Unsupported old gcc versions - hardened needs this :( 219 # Unsupported old gcc versions - hardened needs this :(
177 if [[ $(gcc-major-version) -lt 4 ]] ; then 220 if [[ $(gcc-major-version) -lt 4 ]] ; then
178 ewarn "Appending -fno-stack-protector to CXXFLAGS" 221 ewarn "Appending -fno-stack-protector to CXXFLAGS"
179 append-cxxflags -fno-stack-protector 222 append-cxxflags -fno-stack-protector
180 # Bug 253127 223 # Bug 253127
181 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
182 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 225 -i mkspecs/common/g++.conf || die
183 fi 226 fi
184 227
185 # Bug 261632 228 # Bug 261632
186 if use ppc64; then 229 if use ppc64; then
187 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
188 append-flags -mminimal-toc 231 append-flags -mminimal-toc
189 fi 232 fi
190 233
234 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "/^SYSTEM_VARIABLES=/i \
236 CC='$(tc-getCC)'\n\
237 CXX='$(tc-getCXX)'\n\
238 CFLAGS='${CFLAGS}'\n\
239 CXXFLAGS='${CXXFLAGS}'\n\
240 LDFLAGS='${LDFLAGS}'\n" \
241 -i configure || die "sed SYSTEM_VARIABLES failed"
242
243 # Bug 321335
244 find config.tests/unix -name '*.test' -type f -exec grep -lZ \$MAKE '{}' \; | xargs -0 \
245 sed -e "s:\(\$MAKE\):\1 CC='$(tc-getCC)' CXX='$(tc-getCXX)' LINK='$(tc-getCXX)':g" \
246 -i || die "sed test compilers failed"
247
191 # Bug 172219 248 # Bug 172219
192 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 249 sed -e "s:X11R6/::" -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
193 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
194 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
195 -e "s:X11R6/::" \
196 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
197 250
198 if [[ ${CHOST} != *-darwin* ]]; then 251 if [[ ${CHOST} == *-darwin* ]]; then
199 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
200 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
201 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
202 -i mkspecs/common/g++.conf || die "sed mkspecs/common/g++.conf failed"
203 else
204 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 252 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
205 # crippled (by design) :/ 253 # crippled (by design) :/
206 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 254 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
207 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 255 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
208 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 256 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
220 -e "s:-arch \$i::" \ 268 -e "s:-arch \$i::" \
221 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 269 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
222 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 270 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
223 -e "s:-Xarch_x86_64::g" \ 271 -e "s:-Xarch_x86_64::g" \
224 -e "s:-Xarch_ppc64::g" \ 272 -e "s:-Xarch_ppc64::g" \
225 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 273 -i configure mkspecs/common/mac-g++.conf || die "sed -arch/-Xarch failed"
226 274
227 # On Snow Leopard don't fall back to 10.5 deployment target. 275 # On Snow Leopard don't fall back to 10.5 deployment target.
228 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 276 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
229 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 277 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
230 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 278 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
231 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 279 -i configure mkspecs/common/mac-g++.conf || die "sed deployment target failed"
232 fi 280 fi
233 fi 281 fi
234 282
235 # this one is needed for all systems with a separate -liconv, apart from 283 # this one is needed for all systems with a separate -liconv, apart from
236 # Darwin, for which the sources already cater for -liconv 284 # Darwin, for which the sources already cater for -liconv
248 # use GCC over SunStudio 296 # use GCC over SunStudio
249 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 297 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
250 # don't flirt with non-Prefix stuff, we're quite possessive 298 # don't flirt with non-Prefix stuff, we're quite possessive
251 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 299 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
252 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 300 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
301 # strip predefined CFLAGS from qmake ( bug #312689 )
302 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
253 303
254 base_src_prepare 304 base_src_prepare
255} 305}
256 306
257# @FUNCTION: qt4-build_src_configure 307# @FUNCTION: qt4-build_src_configure
264 # this one is needed for all systems with a separate -liconv, apart from 314 # this one is needed for all systems with a separate -liconv, apart from
265 # Darwin, for which the sources already cater for -liconv 315 # Darwin, for which the sources already cater for -liconv
266 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 316 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
267 myconf+=" -liconv" 317 myconf+=" -liconv"
268 318
269 if has glib ${IUSE//+} && use glib; then 319 if use_if_iuse glib; then
270 # use -I, -L and -l from configure 320 # use -I, -L and -l from configure
271 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 321 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
272 # avoid the -pthread argument 322 # avoid the -pthread argument
273 myconf+=" ${glibflags//-pthread}" 323 myconf+=" ${glibflags//-pthread}"
274 unset glibflags 324 unset glibflags
275 fi 325 fi
276 326
327 if use_if_iuse qpa; then
328 ewarn
329 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
330 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
331 ewarn "disable it before reporting any bugs related to this useflag."
332 ewarn
333 myconf+=" -qpa"
334 fi
335
277 if use aqua ; then 336 if use aqua ; then
278 # On (snow) leopard use the new (frameworked) cocoa code. 337 # On (snow) leopard use the new (frameworked) cocoa code.
279 if [[ $(uname -r | cut -d . -f 1) -ge 9 ]] ; then 338 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
280 myconf+=" -cocoa -framework" 339 myconf+=" -cocoa -framework"
281 340
282 # We are crazy and build cocoa + qt3support :-) 341 # We are crazy and build cocoa + qt3support :-)
283 if use qt3support; then 342 if use qt3support; then
284 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 343 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
298 fi 357 fi
299 358
300 echo ./configure ${myconf} 359 echo ./configure ${myconf}
301 ./configure ${myconf} || die "./configure failed" 360 ./configure ${myconf} || die "./configure failed"
302 myconf="" 361 myconf=""
362
363 prepare_directories ${QT4_TARGET_DIRECTORIES}
303} 364}
304 365
305# @FUNCTION: qt4-build_src_compile 366# @FUNCTION: qt4-build_src_compile
367# @DESCRIPTION:
306# @DESCRIPTION: Actual compile phase 368# Actual compile phase
307qt4-build_src_compile() { 369qt4-build_src_compile() {
308 setqtenv 370 setqtenv
309 371
310 build_directories ${QT4_TARGET_DIRECTORIES} 372 build_directories ${QT4_TARGET_DIRECTORIES}
311} 373}
312 374
375# @FUNCTION: qt4-build_src_test
376# @DESCRIPTION:
377# Runs tests only in target directories.
378qt4-build_src_test() {
379 for dir in ${QT4_TARGET_DIRECTORIES}; do
380 emake -j1 check -C ${dir}
381 done
382}
383
313# @FUNCTION: fix_includes 384# @FUNCTION: fix_includes
314# @DESCRIPTION: 385# @DESCRIPTION:
315# For MacOSX we need to add some symlinks when frameworks are 386# For MacOS X we need to add some symlinks when frameworks are
316# being used, to avoid complications with some more or less stupid packages. 387# being used, to avoid complications with some more or less stupid packages.
317fix_includes() { 388fix_includes() {
318 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 389 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
319 # Some packages tend to include <Qt/...> 390 # Some packages tend to include <Qt/...>
320 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 391 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
340# @DESCRIPTION: 411# @DESCRIPTION:
341# Perform the actual installation including some library fixes. 412# Perform the actual installation including some library fixes.
342qt4-build_src_install() { 413qt4-build_src_install() {
343 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 414 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
344 setqtenv 415 setqtenv
416
345 install_directories ${QT4_TARGET_DIRECTORIES} 417 install_directories ${QT4_TARGET_DIRECTORIES}
346 install_qconfigs 418 install_qconfigs
347 fix_library_files 419 fix_library_files
348 fix_includes 420 fix_includes
421
422 # remove .la files since we are building only shared Qt libraries
423 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm
349} 424}
350 425
351# @FUNCTION: setqtenv 426# @FUNCTION: setqtenv
427# @INTERNAL
352setqtenv() { 428setqtenv() {
353 # Set up installation directories 429 # Set up installation directories
354 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
355 QTPREFIXDIR=${EPREFIX}/usr 430 QTPREFIXDIR=${EPREFIX}/usr
356 QTBINDIR=${EPREFIX}/usr/bin 431 QTBINDIR=${EPREFIX}/usr/bin
357 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 432 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
358 QMAKE_LIBDIR_QT=${QTLIBDIR}
359 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 433 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
360 QTDATADIR=${EPREFIX}/usr/share/qt4
361 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 434 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
362 QTHEADERDIR=${EPREFIX}/usr/include/qt4 435 QTHEADERDIR=${EPREFIX}/usr/include/qt4
363 QTPLUGINDIR=${QTLIBDIR}/plugins 436 QTPLUGINDIR=${QTLIBDIR}/plugins
437 QTIMPORTDIR=${QTLIBDIR}/imports
438 QTDATADIR=${EPREFIX}/usr/share/qt4
439 QTTRANSDIR=${QTDATADIR}/translations
364 QTSYSCONFDIR=${EPREFIX}/etc/qt4 440 QTSYSCONFDIR=${EPREFIX}/etc/qt4
365 QTTRANSDIR=${QTDATADIR}/translations
366 QTEXAMPLESDIR=${QTDATADIR}/examples 441 QTEXAMPLESDIR=${QTDATADIR}/examples
367 QTDEMOSDIR=${QTDATADIR}/demos 442 QTDEMOSDIR=${QTDATADIR}/demos
443 QMAKE_LIBDIR_QT=${QTLIBDIR}
368 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 444 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
445
369 PLATFORM=$(qt_mkspecs_dir) 446 PLATFORM=$(qt_mkspecs_dir)
370 447
371 unset QMAKESPEC 448 unset QMAKESPEC
372} 449}
373 450
374# @FUNCTION: standard_configure_options 451# @FUNCTION: standard_configure_options
452# @INTERNAL
375# @DESCRIPTION: 453# @DESCRIPTION:
376# Sets up some standard configure options, like libdir (if necessary), whether 454# Sets up some standard configure options, like libdir (if necessary), whether
377# debug info is wanted or not. 455# debug info is wanted or not.
378standard_configure_options() { 456standard_configure_options() {
379 local myconf= 457 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
458 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
459 -importdir ${QTIMPORTDIR} -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR}
460 -sysconfdir ${QTSYSCONFDIR} -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
461 -opensource -confirm-license -shared -fast -largefile -stl -verbose
462 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
380 463
381 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 464 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
382 465
383 # Disable visibility explicitly if gcc version isn't 4 466 # debug/release
384 if [[ $(gcc-major-version) -lt 4 ]]; then
385 myconf+=" -no-reduce-exports"
386 fi
387
388 # precompiled headers doesn't work on hardened, where the flag is masked.
389 myconf+=" $(qt_use pch)"
390
391 if use debug; then 467 if use debug; then
392 myconf+=" -debug" 468 myconf+=" -debug"
393 else 469 else
394 myconf+=" -release" 470 myconf+=" -release"
395 fi 471 fi
396 myconf+=" -no-separate-debug-info" 472 myconf+=" -no-separate-debug-info"
397 473
474 # exceptions USE flag
475 local exceptions="-exceptions"
476 in_iuse exceptions && exceptions="$(qt_use exceptions)"
477 myconf+=" ${exceptions}"
478
479 # disable RPATH on Qt >= 4.8 (bug 380415)
480 version_is_at_least 4.8 && myconf+=" -no-rpath"
481
482 # precompiled headers don't work on hardened, where the flag is masked
483 myconf+=" $(qt_use pch)"
484
485 # -reduce-relocations
486 # This flag seems to introduce major breakage to applications,
487 # mostly to be seen as a core dump with the message "QPixmap: Must
488 # construct a QApplication before a QPaintDevice" on Solaris.
489 # -- Daniel Vergien
490 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
491
398 use aqua && myconf+=" -no-framework" 492 use aqua && myconf+=" -no-framework"
399 493
400 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 494 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
401 # $(tc-arch). Therefore we convert it to supported values. 495 # $(tc-arch). Therefore we convert it to supported values.
402 case "$(tc-arch)" in 496 case "$(tc-arch)" in
403 amd64|x64-*) myconf+=" -arch x86_64" ;; 497 amd64|x64-*) myconf+=" -arch x86_64" ;;
404 ppc-macos) myconf+=" -arch ppc" ;; 498 ppc-macos) myconf+=" -arch ppc" ;;
405 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;; 499 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
406 sparc|sparc-*) myconf+=" -arch sparc" ;; 500 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
407 x86-macos) myconf+=" -arch x86" ;; 501 x86-macos) myconf+=" -arch x86" ;;
408 x86|x86-*) myconf+=" -arch i386" ;; 502 x86|x86-*) myconf+=" -arch i386" ;;
409 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;; 503 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
410 hppa|sh) myconf+=" -arch generic" ;; 504 hppa|sh) myconf+=" -arch generic" ;;
411 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 505 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
412 esac 506 esac
413 507
414 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build
415 local exceptions=
416 case "${PV}" in
417 4.6.*)
418 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then
419 case "${PV}:${CHOST}" in
420 4.6.0*:*-darwin*)
421 : # http://bugreports.qt.nokia.com/browse/QTBUG-5909
422 # workaround for compilation error on OSX (qt-gui)
423 ;;
424 *)
425 exceptions="-no-exceptions"
426 ;;
427 esac
428 fi
429 ;;
430 *)
431 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
432 ;;
433 esac
434
435 # note about -reduce-relocations:
436 # That flag seems to introduce major breakage to applications,
437 # mostly to be seen as a core dump with the message "QPixmap: Must
438 # construct a QApplication before a QPaintDevice" on Solaris
439 # -- Daniel Vergien
440 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
441
442 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
443 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
444 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
445 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
446 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
447 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
448 ${exceptions}
449 -nomake examples -nomake demos"
450
451 echo "${myconf}" 508 echo "${myconf}"
452} 509}
453 510
454# @FUNCTION: build_directories 511# @FUNCTION: prepare_directories
455# @USAGE: < directories > 512# @USAGE: < directories >
513# @INTERNAL
456# @DESCRIPTION: 514# @DESCRIPTION:
457# Compiles the code in $QT4_TARGET_DIRECTORIES 515# Generates Makefiles for the given list of directories.
458build_directories() { 516prepare_directories() {
459 for x in "$@"; do 517 for x in "$@"; do
460 pushd "${S}"/${x} >/dev/null 518 pushd "${S}"/${x} >/dev/null || die
519 einfo "Running qmake in: ${x}"
461 # avoid running over the maximum argument number, bug #299810 520 # avoid running over the maximum argument number, bug #299810
462 { 521 {
463 echo "${S}"/mkspecs/common/*.conf 522 echo "${S}"/mkspecs/common/*.conf
464 find "${S}" -name '*.pr[io]' 523 find "${S}" -name '*.pr[io]'
465 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 524 } | xargs sed -i \
525 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
526 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
527 || die
466 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 528 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
467 emake CC="@echo compiling \$< && $(tc-getCC)" \
468 CXX="@echo compiling \$< && $(tc-getCXX)" \
469 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed"
470 popd >/dev/null 529 popd >/dev/null || die
530 done
531}
532
533
534# @FUNCTION: build_directories
535# @USAGE: < directories >
536# @INTERNAL
537# @DESCRIPTION:
538# Compiles the code in the given list of directories.
539build_directories() {
540 for x in "$@"; do
541 pushd "${S}"/${x} >/dev/null || die
542 emake CC="$(tc-getCC)" \
543 CXX="$(tc-getCXX)" \
544 LINK="$(tc-getCXX)" || die "emake failed"
545 popd >/dev/null || die
471 done 546 done
472} 547}
473 548
474# @FUNCTION: install_directories 549# @FUNCTION: install_directories
475# @USAGE: < directories > 550# @USAGE: < directories >
551# @INTERNAL
476# @DESCRIPTION: 552# @DESCRIPTION:
477# run emake install in the given directories, which are separated by spaces 553# Runs emake install in the given directories, which are separated by spaces.
478install_directories() { 554install_directories() {
479 for x in "$@"; do 555 for x in "$@"; do
480 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 556 pushd "${S}"/${x} >/dev/null || die
481 emake INSTALL_ROOT="${D}" install || die "emake install failed" 557 emake INSTALL_ROOT="${D}" install || die "emake install failed"
482 popd >/dev/null || die "Can't popd from ${S}/${x}" 558 popd >/dev/null || die
483 done 559 done
484} 560}
485 561
486# @ECLASS-VARIABLE: QCONFIG_ADD 562# @ECLASS-VARIABLE: QCONFIG_ADD
487# @DESCRIPTION: 563# @DESCRIPTION:
497# @DESCRIPTION: 573# @DESCRIPTION:
498# List variables that should be defined at the top of QtCore/qconfig.h 574# List variables that should be defined at the top of QtCore/qconfig.h
499: ${QCONFIG_DEFINE:=} 575: ${QCONFIG_DEFINE:=}
500 576
501# @FUNCTION: install_qconfigs 577# @FUNCTION: install_qconfigs
578# @INTERNAL
579# @DESCRIPTION:
502# @DESCRIPTION: Install gentoo-specific mkspecs configurations 580# Install gentoo-specific mkspecs configurations.
503install_qconfigs() { 581install_qconfigs() {
504 local x 582 local x
505 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 583 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
506 for x in QCONFIG_ADD QCONFIG_REMOVE; do 584 for x in QCONFIG_ADD QCONFIG_REMOVE; do
507 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 585 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
518 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 596 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
519 fi 597 fi
520} 598}
521 599
522# @FUNCTION: generate_qconfigs 600# @FUNCTION: generate_qconfigs
523# @DESCRIPTION: Generates gentoo-specific configurations 601# @INTERNAL
602# @DESCRIPTION:
603# Generates gentoo-specific qconfig.{h,pri}.
524generate_qconfigs() { 604generate_qconfigs() {
525 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 605 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
526 local x qconfig_add qconfig_remove qconfig_new 606 local x qconfig_add qconfig_remove qconfig_new
527 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 607 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
528 [[ -f ${x} ]] || continue 608 [[ -f ${x} ]] || continue
542 622
543 # generate list of QT_CONFIG entries from the existing list 623 # generate list of QT_CONFIG entries from the existing list
544 # including qconfig_add and excluding qconfig_remove 624 # including qconfig_add and excluding qconfig_remove
545 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 625 for x in $(sed -n 's/^QT_CONFIG +=//p' \
546 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 626 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
547 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 627 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
548 done 628 done
549 629
550 # replace the existing QT_CONFIG list with qconfig_new 630 # replace the existing QT_CONFIG list with qconfig_new
551 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 631 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
552 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 632 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
576 fi 656 fi
577 fi 657 fi
578} 658}
579 659
580# @FUNCTION: qt4-build_pkg_postrm 660# @FUNCTION: qt4-build_pkg_postrm
661# @DESCRIPTION:
581# @DESCRIPTION: Generate configurations when the package is completely removed 662# Regenerate configuration when the package is completely removed.
582qt4-build_pkg_postrm() { 663qt4-build_pkg_postrm() {
583 generate_qconfigs 664 generate_qconfigs
584} 665}
585 666
586# @FUNCTION: qt4-build_pkg_postinst 667# @FUNCTION: qt4-build_pkg_postinst
668# @DESCRIPTION:
587# @DESCRIPTION: Generate configuration, plus throws a message about possible 669# Regenerate configuration, plus throw a message about possible
588# breakages and proposed solutions. 670# breakages and proposed solutions.
589qt4-build_pkg_postinst() { 671qt4-build_pkg_postinst() {
590 generate_qconfigs 672 generate_qconfigs
591
592 if [[ "${PN}" == "qt-core" ]]; then
593 echo
594 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
595 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
596 ewarn "should recompile the packages providing these plugins. Also, make sure you"
597 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
598 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
599 ewarn
600 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
601 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
602 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
603 ewarn "configuration."
604 ewarn
605 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
606 echo
607 fi
608} 673}
609 674
610# @FUNCTION: skip_qmake_build_patch 675# @FUNCTION: skip_qmake_build
676# @INTERNAL
611# @DESCRIPTION: 677# @DESCRIPTION:
612# Don't need to build qmake, as it's already installed from qt-core 678# Patches configure to skip qmake compilation, as it's already installed by qt-core.
613skip_qmake_build_patch() { 679skip_qmake_build() {
614 # Don't need to build qmake, as it's already installed from qt-core
615 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 680 sed -i -e "s:if true:if false:g" "${S}"/configure || die
616} 681}
617 682
618# @FUNCTION: skip_project_generation_patch 683# @FUNCTION: skip_project_generation
684# @INTERNAL
619# @DESCRIPTION: 685# @DESCRIPTION:
620# Exit the script early by throwing in an exit before all of the .pro files are scanned 686# Exit the script early by throwing in an exit before all of the .pro files are scanned.
621skip_project_generation_patch() { 687skip_project_generation() {
622 # Exit the script early by throwing in an exit before all of the .pro files are scanned
623 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 688 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
624 -i "${S}"/configure || die "Sed failed"
625} 689}
626 690
627# @FUNCTION: symlink_binaries_to_buildtree 691# @FUNCTION: symlink_binaries_to_buildtree
692# @INTERNAL
628# @DESCRIPTION: 693# @DESCRIPTION:
629# Symlink generated binaries to buildtree so they can be used during compilation 694# Symlinks generated binaries to buildtree, so they can be used during compilation time.
630# time
631symlink_binaries_to_buildtree() { 695symlink_binaries_to_buildtree() {
632 for bin in qmake moc uic rcc; do 696 for bin in qmake moc uic rcc; do
633 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 697 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
634 done 698 done
635} 699}
636 700
637# @FUNCTION: fix_library_files 701# @FUNCTION: fix_library_files
702# @INTERNAL
638# @DESCRIPTION: 703# @DESCRIPTION:
639# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 704# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
640# moves the *.pc-files into the pkgconfig directory 705# moves the *.pc files into the pkgconfig directory.
641fix_library_files() { 706fix_library_files() {
707 local libfile
642 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 708 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
643 if [[ -e ${libfile} ]]; then 709 if [[ -e ${libfile} ]]; then
644 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 710 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
645 fi 711 fi
646 done 712 done
647 713
648 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 714 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
649 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 715 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
650 if [[ -e ${libfile} ]]; then 716 if [[ -e ${libfile} ]]; then
651 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 717 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
652 718
653 # Move .pc files into the pkgconfig directory 719 # Move .pc files into the pkgconfig directory
654 dodir ${QTPCDIR#${EPREFIX}} 720 dodir ${QTPCDIR#${EPREFIX}}
655 mv ${libfile} "${D}"/${QTPCDIR}/ \ 721 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
656 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
657 fi 722 fi
658 done 723 done
659 724
660 # Don't install an empty directory 725 # Don't install an empty directory
661 rmdir "${D}"/${QTLIBDIR}/pkgconfig 726 rmdir "${D}"/${QTLIBDIR}/pkgconfig
662} 727}
663 728
664# @FUNCTION: qt_use 729# @FUNCTION: qt_use
665# @USAGE: < flag > [ feature ] [ enableval ] 730# @USAGE: < flag > [ feature ] [ enableval ]
666# @DESCRIPTION: 731# @DESCRIPTION:
667# This will echo "${enableval}-${feature}" if <flag> is enabled, or 732# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
668# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 733# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
669# will be used for that. If [enableval] is not specified, it omits the 734# will be used for that. If [enableval] is not specified, it omits the
670# assignment-part 735# "-${enableval}" part.
671qt_use() { 736qt_use() {
672 local flag=$1 737 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
673 local feature=$1
674 local enableval=
675
676 [[ -n $2 ]] && feature=$2
677 [[ -n $3 ]] && enableval=-$3
678
679 if use ${flag}; then
680 echo "${enableval}-${feature}"
681 else
682 echo "-no-${feature}"
683 fi
684} 738}
685 739
686# @FUNCTION: qt_mkspecs_dir 740# @FUNCTION: qt_mkspecs_dir
687# @RETURN: the specs-directory w/o path 741# @RETURN: the specs-directory w/o path
688# @DESCRIPTION: 742# @DESCRIPTION:
689# Allows us to define which mkspecs dir we want to use. 743# Allows us to define which mkspecs dir we want to use.
690qt_mkspecs_dir() { 744qt_mkspecs_dir() {
691 # Allows us to define which mkspecs dir we want to use.
692 local spec 745 local spec=
693
694 case ${CHOST} in 746 case ${CHOST} in
695 *-freebsd*|*-dragonfly*) 747 *-freebsd*|*-dragonfly*)
696 spec=freebsd ;; 748 spec=freebsd ;;
697 *-openbsd*) 749 *-openbsd*)
698 spec=openbsd ;; 750 spec=openbsd ;;
710 *-solaris*) 762 *-solaris*)
711 spec=solaris ;; 763 spec=solaris ;;
712 *-linux-*|*-linux) 764 *-linux-*|*-linux)
713 spec=linux ;; 765 spec=linux ;;
714 *) 766 *)
715 die "Unknown CHOST, no platform choosen." 767 die "Unknown CHOST, no platform chosen"
716 esac 768 esac
717 769
718 CXX=$(tc-getCXX) 770 CXX=$(tc-getCXX)
719 if [[ ${CXX} == *g++* ]]; then 771 if [[ ${CXX} == *g++* ]]; then
720 spec+=-g++ 772 spec+=-g++
721 elif [[ ${CXX} == *icpc* ]]; then 773 elif [[ ${CXX} == *icpc* ]]; then
722 spec+=-icc 774 spec+=-icc
723 else 775 else
724 die "Unknown compiler ${CXX}." 776 die "Unknown compiler '${CXX}'"
725 fi 777 fi
726 if [[ -n ${LIBDIR/lib} ]]; then 778 if [[ -n ${LIBDIR/lib} ]]; then
727 spec+=-${LIBDIR/lib} 779 spec+=-${LIBDIR/lib}
728 fi 780 fi
729 781
738 fi 790 fi
739 791
740 echo "${spec}" 792 echo "${spec}"
741} 793}
742 794
795# @FUNCTION: qt_assistant_cleanup
796# @INTERNAL
797# @DESCRIPTION:
798# Tries to clean up tools.pro for qt-assistant ebuilds.
799# Meant to be called in src_prepare().
800# Since Qt 4.7.4 this function is a no-op.
801qt_assistant_cleanup() {
802 # apply patching to qt-assistant ebuilds only
803 [[ ${PN} != "qt-assistant" ]] && return
804
805 # no longer needed for 4.7.4 and later
806 version_is_at_least "4.7.4" && return
807
808 # different versions (and branches...) may need different handling,
809 # add a case if you need special handling
810 case "${MY_PV_EXTRA}" in
811 *kde-qt*)
812 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
813 -e "/mac/,/^embedded.*makeqpf$/d" \
814 -i tools/tools.pro || die "patching tools.pro failed"
815 ;;
816 *)
817 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
818 -e "/mac/,/^embedded.*makeqpf$/d" \
819 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
820 -i tools/tools.pro || die "patching tools.pro failed"
821 ;;
822 esac
823}
824
825# @FUNCTION: qt_nolibx11
826# @INTERNAL
827# @DESCRIPTION:
828# Ignore X11 tests for packages that don't need X libraries installed.
829qt_nolibx11() {
830 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
831 die "x11 check sed failed"
832}
833
743EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 834EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.60  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.20